<?php
/*
Plugin Name: my SEO Status
Plugin Script: myseostatus.php
Plugin URI: http://www.myWordPress.com
Description: Automatically checks how well indexed your blog is, and how many other webpages are linking to you!
Version: 1.2
Author: myWordPress.com
Author URI: http://www.myWordPress.com
Min WP Version: 2.7
Max WP Version: 2.8
Update Server: http://www.myWordPress.com


=== RELEASE NOTES ===
2009-06-30 - v1.0   	- First Version - public beta test version.
2009-07-04 - v1.1   	- Speed optimization. Making sure the plugin only checks status once a day. 		
2009-07-23 - v1.2   	- The plugin is now using WordPress's built in implementation of fopen and cURL.
						- A 'Settings'-link have been added to the Plugins page
						- A small typo has been fixed that was spotted by Lars Bachmann. 


*/





/*  Copyright 2008-2009  myWordPress.com  (email : contact@mywordpress.com)

	This plugin checks the status of how many pages of your blog you have indexed in Google, Yahoo, Altavista and Bing.com
	it also checks how many other pages links to your blog from Google, Yahoo and Altavista (Bing.com does not support this feature).
	
	The data is presented both when you log in to your WordPress Dashboard as an admin, and in the plugin page it displays
	the historic data in nice looking graphs.

	Charts are rendered using FusionCharts Free - Read more here: http://www.fusioncharts.com
	
	A small javascript code is used from the FeedStats plugin (by Andrés Nieto), 
	http://bueltge.de/wp-feedstats-de-plugin/171/

	

*/


// ### No direct access to the plugin outside Wordpress
if (preg_match('#'.basename(__FILE__) .'#', $_SERVER['PHP_SELF'])) { 
	die('Direct access to this file is not allowed!'); 
}



//### Function strips http:// or https://
function myseostatus_remove_http($url = ''){
		if ($url == 'http://' OR $url == 'https://')
		{
			return $url;
		}
		$matches = substr($url, 0, 7);
		if ($matches=='http://') 
		{
			$url = substr($url, 7);		
		}
		else
		{
			$matches = substr($url, 0, 8);
			if ($matches=='https://') 
			$url = substr($url, 8);
		}
		return $url;
}
	



// ### Base installation function for my SEO Status
function myseostatus_install () { // Database setup. Runs first time plugin is activated
	global $wpdb;
	$table_name = $wpdb->prefix . "myseostatus";	
	if ( $wpdb->get_var("show tables like '$table_name'") != $table_name ) {
	    if ( file_exists(ABSPATH . 'wp-admin/includes/upgrade.php') ) {
	    	require_once(ABSPATH . '/wp-admin/includes/upgrade.php');
	    } else { // Wordpress <= 2.2
	    	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	    }
	    
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		dbDelta("CREATE TABLE `$table_name` (
  					`id` int(11) NOT NULL auto_increment,
					`date` date NOT NULL,
					`datatype` varchar(10) collate utf8_danish_ci NOT NULL,
					`value` int(11) NOT NULL,
					UNIQUE KEY `id` (`id`),
					KEY `datatype` (`datatype`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_danish_ci;");
	}
	else  //Table exists....
	{ //Table does indeed exist, here we can make updates automatically if needed.
	}
	update_option(PLUGIN_MYSEOSTATUS_LAST_CRON, ''); // Set last cron to 0, so we get an immediate update...

}


}


//This function displays current status in the Dashboard if requested.
function myseostatus_dashboard_widget_function() {
    global $wpdb;
    $table_name = $wpdb->prefix . "myseostatus";	
    $baseurl=WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)). '/mywordpresssm.jpg';	
    echo "<p><a href='http://mywordpress.com' target='_blank'><img src='$baseurl' border=0></a>";	
    echo "<p><a href='options-general.php?page=myseostatus.php'>See Historic Graphs</a>";
    myseostatus_displaystats();
} 



if (!function_exists('myseostatus_add_dashboard_widgets')){
	function myseostatus_add_dashboard_widgets() {
		wp_add_dashboard_widget('myseostatus_dashboard_widget', 'my SEO Status', 'myseostatus_dashboard_widget_function');	
	} 
} 


// ### Returns number of indexed pages in bing.com
function myseostatus_checkbingindex($inurl) {
	$theregex = "/ of (.*?) results<\/span>/Ui";
	$theurl = "http://www.bing.com/search?q=site:".$inurl."&go=&form=QBRE&filt=all&setmkt=en-US&setlang=en-US";
	$thepage=wp_remote_fopen($theurl);
	preg_match_all( $theregex, $thepage, $thematch );
	$indexbing = $thematch[1][0];
	$indexbing=preg_replace("/[^0-9\d]/i", "", $indexbing);
	if(!$indexbing){
		$indexbing=0;
	}
	return $indexbing;
}
	
	
	
	
// ### Returns number of indexed pages in altavista.com
function myseostatus_checkaltavistaindex($inurl) {
	$theregex = "/ of (.*?) results<\/span>/Ui";
		//9999'">AltaVista found 9,220 results</a></b>&nbsp;
	$theregex = "/AltaVista found (.*?) results<\/a><\/b>/Ui";
	$theurl = "http://www.altavista.com/web/results?itag=ody&q=site%3A".$inurl."&kgs=0&kls=0";
	$thepage=wp_remote_fopen($theurl);
	preg_match_all( $theregex, $thepage, $thematch );
	$indexaltavista = $thematch[1][0];
	$indexaltavista=preg_replace("/[^0-9\d]/i", "", $indexaltavista);
	if(!$indexaltavista){
		$indexaltavista=0;
	}
	return $indexaltavista;
}	
	
	
// ### Returns number of backlinks in altavista.com
function myseostatus_checkaltavistalinks($inurl) {
	$theregex = "/ of (.*?) results<\/span>/Ui";
		//9999'">AltaVista found 9,220 results</a></b>&nbsp;
	$theregex = "/AltaVista found (.*?) results<\/a><\/b>/Ui";
	$theurl = "http://www.altavista.com/web/results?itag=ody&q=link%3A".$inurl."&kgs=0&kls=0";
	$thepage=wp_remote_fopen($theurl);
	preg_match_all( $theregex, $thepage, $thematch );
	$indexaltavista = $thematch[1][0];
	$indexaltavista=preg_replace("/[^0-9\d]/i", "", $indexaltavista);
	if(!$indexaltavista){
		$indexaltavista=0;
	}
	return $indexaltavista;
}
	
	
// ### Returns number of indexed pages in bing.com
function myseostatus_checkbinglinks($inurl) {
	$theregex = "/ of (.*?) results<\/span>/Ui";
	$theurl = "http://www.bing.com/search?q=link:".$inurl."&go=&form=QBRE&filt=all&setmkt=en-US&setlang=en-US";
	echo $theurl;
	
	$thepage=wp_remote_fopen($theurl);
	preg_match_all( $theregex, $thepage, $thematch );
	$indexbing = $thematch[1][0];
	$indexbing=preg_replace("/[^0-9\d]/i", "", $indexbing);
	if(!$indexbing){
		$indexbing=0;
	}
	return $indexbing;
}
		
	
// ### Returns number of indexed pages in Google
function myseostatus_checkgoogleindex($inurl) {

	$checkurl  = "http://www.google.com/search?q=site%3A".$inurl."&start=0&ie=utf-8&oe=utf-8";
	$result=wp_remote_fopen($checkurl);
	//Do the pregging
	$count = preg_match_all("| of about (.*) from |Ui", $result, $out, PREG_PATTERN_ORDER);
	
	if ($count == 0)
	{
		$count = preg_match_all("| of (.*) from |Ui", $result, $out, PREG_PATTERN_ORDER);
		$name = $out[0][0];
		$name = str_replace(' of ','',$name);
		$name = str_replace(' from ','',$name);
		$name = str_replace(',','',$name);
	}
	else
	{
		$name = $out[0][0];
		$name = str_replace(' of about ','',$name);
		$name = str_replace(' from ','',$name);
		$name = str_replace(',','',$name);
	}
	
	$name=preg_replace("/[^0-9\d]/i", "", $name);
	
	if(!$name){
		$name=0;
	}
	$name=strip_tags($name);
	return $name;
}


// ### Returns number of backlinks in Google
function myseostatus_checkgooglelinks($inurl) {
	$theregex = "/of (.*?) linking to/";
	$theurl = "http://www.google.com/search?hl=en&lr=&q=link%3A".$inurl."&btnG=Search";
	$thepage = wp_remote_fopen( $theurl );
	preg_match_all( $theregex, $thepage, $thematch );
	$googlelinks = $thematch[1][0];
	$googlelinks=preg_replace("/[^0-9\d]/i", "", $googlelinks);
	if(!$googlelinks){
		$googlelinks=0;
	}
	$googlelinks=strip_tags($googlelinks);
	return $googlelinks;
}




// ### Returns number of indexed pages in Yahoo
function myseostatus_checkyahooindex($inurl) {
	$checkurl = "http://siteexplorer.search.yahoo.com/search?p=".urlencode($inurl)."&bwm=p&bwms=p&fr=yfp-t-500&fr2=seo-rd-se";

	$theregex = '/<span class="btn">Pages (.*?)<i/';
	$theurl = "http://siteexplorer.search.yahoo.com/search?p=http%3A%2F%2F" . $inurl . "&amp;bwm=p&amp;bwms=p&amp;fr=yfp-t-501&amp;fr2=seo-rd-se";
	$thepage=wp_remote_fopen($theurl);
	preg_match_all( $theregex, $thepage, $thematch );
	$indexyahoo = $thematch[1][0];
	$indexyahoo =preg_replace('/[^0-9\s]/', '', $indexyahoo);
	if(!$indexyahoo){
		$indexyahoo=0;
	}
	return $indexyahoo;
}



// ### Returns number of backlinks in Yahoo
function myseostatus_checkyahoolinks($inurl) {
//<span class="btn">Inlinks (9,310)<i class="tl">
	$theregex = '/<span class="btn">Inlinks (.*?)<i/';
	$theurl = "http://siteexplorer.search.yahoo.com/search?p=".urlencode($inurl)."&bwm=i&bwmo=d&bwmf=s";
	$thepage=wp_remote_fopen($theurl);
//	echo $thepage;
	preg_match_all( $theregex, $thepage, $thematch );
	$linksyahoo = $thematch[1][0];

	$linksyahoo =preg_replace('/[^0-9\s]/', '', $linksyahoo);

	if(!$linksyahoo){
		$linksyahoo=0;
	}
	return $linksyahoo;
}
	
	
		
		
// ### Returns a truncated string based on the parameters
function myseostatus_truncatestring($string, $del) {
  $len = strlen($string);
  if ($len > $del) {
    $new = substr($string,0,$del)."...";
    return $new;
  }
  else return $string;
}

// ### Displays stats.  
function myseostatus_displaystats() {
 	global $wpdb, $wp_version;
 	$table_name = $wpdb->prefix . "myseostatus";	

	$indexgoogle = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'gindex' order by `date` desc");
	$googlelinks = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'glinks' order by `date` desc");
	
	$indexyahoo = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'yindex' order by `date` desc");
	$yahoolinks = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'ylinks' order by `date` desc");

	$indexaltavista = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'aindex' order by `date` desc");
	$linksaltavista = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'alinks' order by `date` desc");

	$indexbing = (int) $wpdb->get_var("SELECT value  FROM `$table_name` WHERE `datatype` = 'bindex' order by `date` desc");

	$now=time();

	echo "<table cellspacing=2 ><tr><td><h5>Google</h5></td><td><h5>Yahoo</h5></td><td><h5>Altavista.com</h5></td><td><h5>Bing.com</h5></td></tr>";

//Google
	echo "<tr valign=top>";
	echo "<td><table cellspacing=5 cellpadding=5><tr><td><small>Indexation</small></td><td><small>Backlinks</small></td></tr>";
	echo "<tr cellspacing=4 align=center><td>".number_format_i18n($indexgoogle)."</td><td>".number_format_i18n($googlelinks)."</td></tr>";
	echo "</table></td>";
	

//Yahoo	

	echo "<td><table cellspacing=5 cellpadding=5><tr><td><small>Indexation</small></td><td><small>Backlinks</small></td></tr>";
	echo "<tr cellspacing=4 align=center><td>".number_format_i18n($indexyahoo)."</td><td>".number_format_i18n($yahoolinks)."</td></tr>";
	echo "</table></td>";
	

//Altavista

	echo "<td><table cellspacing=5 cellpadding=5><tr><td><small>Indexation</small></td><td><small>Backlinks</small></td></tr>";
	echo "<tr cellspacing=4 align=center><td>".number_format_i18n($indexaltavista)."</td><td>".number_format_i18n($linksaltavista)."</td></tr>";
	echo "</table></td>";
	


//Bing.com

	echo "<td><table cellspacing=5 cellpadding=5><tr><td><small>Indexation</small></td><td><small>Backlinks</small></td></tr>";
	echo "<tr cellspacing=4 align=center><td>".number_format_i18n($indexbing)."</td><td>-</td></tr>";
	echo "</table></td>";
	
	
	
	echo "</tr></table>";
//	echo "<p>Data last checked ".human_time_diff(strtotime($lastcheckyahoo. " UTC"),current_time('timestamp'))." ago</p>";	

	
}


// ### Function that sorts an array by a subkey.
function myseostatus_sksort(&$array, $subkey="id", $sort_ascending=false) {

    if (count($array))
        $temp_array[key($array)] = array_shift($array);

    foreach($array as $key => $val){
        $offset = 0;
        $found = false;
        foreach($temp_array as $tmp_key => $tmp_val)
        {
            if(!$found and strtolower($val[$subkey]) > strtolower($tmp_val[$subkey]))
            {
                $temp_array = array_merge(    (array)array_slice($temp_array,0,$offset),
                                            array($key => $val),
                                            array_slice($temp_array,$offset)
                                          );
                $found = true;
            }
            $offset++;
        }
        if(!$found) $temp_array = array_merge($temp_array, array($key => $val));
    }

    if ($sort_ascending) $array = array_reverse($temp_array);

    else $array = $temp_array;
}

// ### Checks for presence of the curl extension.
function myseostatus_iscurlinstalled() {
	if  (in_array  ('curl', get_loaded_extensions())) {
		return true;
	}
	else{
		return false;
	}
}


// ### The Admin options/settings screen
function myseostatus_admin_options(){
 	global $wpdb, $wp_version,$wp_locale;
 	$table_name = $wpdb->prefix . "myseostatus";	
 	$blogurl=myseostatus_remove_http(get_bloginfo('url'));	
	$baseurl=WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)). '/';	


//----------------------------------------------
//Clearing the database!!
//----------------------------------------------

	if ( ($_POST['action'] == 'clear') && $_POST['myseostatus_clear'] ) {
		$nonce=$_POST['_myseostatusnonce'];
	    if (! wp_verify_nonce($nonce, '_myseostatusnonce') ) die("Failed security check");
	    	
		if ( function_exists('current_user_can') && current_user_can('edit_plugins') ) {
			
			$wpdb->query ("TRUNCATE TABLE `$table_name`");
			update_option(PLUGIN_MYSEOSTATUS_LAST_CRON, ''); // Set last cron to 0, so we get an immediate update...

			echo '<div class="updated fade"><p>' . __('my SEO Status Database has been cleared!', 'myseostatus') . '</p></div>';
		} else {
			wp_die('<p>'.__('You do not have sufficient permissions.').'</p>');
		}
	}
	



//----------------------------------------------
//Saving settings
//----------------------------------------------
	if ( ($_POST['action'] == 'insert') && $_POST['myseostatus_save'] ) {
	
		$nonce=$_POST['_myseostatusnonce'];
	    if (! wp_verify_nonce($nonce, 'myseostatus') ) die("Failed security check");

		if ( function_exists('current_user_can') && current_user_can('edit_plugins') ) {
		
			echo '<div class="updated fade"><p>' . __('The options have been saved!', 'myseostatus') . '</p></div>';
		} else {
			wp_die('<p>'.__('You do not have sufficient permissions.').'</p>');
		}
	}
	
	
	
	  
    
    ?>
<div class="wrap">
	<h2><?php _e("my SEO Status v1.2", 'myseostatus'); ?> </h2>
    <br class="clear" />
    <p><em>- A clever WordPress Plugin by <a href="http://mywordpress.com">myWordPress.com</a></em></p>

    <?php
		if (!myseostatus_iscurlinstalled())  {
			_e("<div id='error'><p class='error'>The cUrl PHP extension is <strong>not installed</strong>. Please fix this. Before this is fixed, this plugin will not function properly!</p></div>");
		}
    ?>
    

		<div id="poststuff" class="ui-sortable">
			<div class="postbox open" >
				<h3><?php _e('Indexation And Backlinks Status', 'myseostatus'); ?></h3>
				<div class="inside">
					<?php myseostatus_displaystats();  ?>
		    		<P><strong>Legend:</strong><br>
					<em>Indexation: Number of indexed pages from your blog.<br>
					Backlinks: Number of links pointing to your blog from other blog/websites.<br>
					Note: Backlink analysis is currently not available from Bing.com.</em></p>
				</div>
			</div>
		</div>
			
			
   		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('FAQ', 'myseostatus'); ?></h3>
				<div class="inside">
				<h4>What does mySEOStatus do?</h4>

<p>mySEOStatus checks how much the search engines know about your blog, and displays the historic changes it records.</p>

<p>It does this by checking Google, Yahoo, Altavista and Bing.com for two things: </p>
<ul>
<li>1. How many pages do they know about your blog? (Indexation)</li>
<li>2. How many other blogs/websites link to your blog? (Backlinks)</li>
</ul>

<p>mySEOStatus does this by checking each of these numbers once every day.</p>

<p>These numbers give you an opportunity to check how well your blog is doing in the search engines.</p>

<h4>Can I check manually?</h4>
<p>Of course you can, and in the section named "Links for Manual Checking" contains direct links to the pages that mySEOStatus use to check the numbers.</p>

<h4>The numbers are different when I check manually?</h4>

<p>mySEOStatus checks these numbers once every day. If you check manually at another time, the numbers might differ slightly. Having an hourly check is overkill for this kind of information, as the numbers fluctuate for all blogs/websites. </p>


				</div>
			</div>
		</div>  			


		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('Indexation Graphs', 'myseostatus'); ?></h3>
				<div class="inside">    
				
				
	

<SCRIPT LANGUAGE="Javascript" SRC="<?php echo $baseurl; ?>FusionCharts.js"></SCRIPT>
			<?php
				include("FusionCharts.php"); //Include the FusionCharts.php file
				

	$highgooglevalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='gindex' order by `value` desc");
	$lowgooglevalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='gindex' order by `value` asc");

	$sql= "SELECT *
	FROM (
	
	SELECT `id` , `Date` , `datatype` , `value`
	FROM `$table_name`
	WHERE `datatype` = 'gindex'
	ORDER BY rand( )
	
	) dt
	ORDER BY (
	(
	CASE `Date`
	WHEN '".$firstdate."'
	THEN 0
	ELSE 1
	END
	) + (
	CASE `Date`
	WHEN '".$lastdate."'
	THEN 0
	ELSE 1
	END )
	), `Date` LIMIT 15";


	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='gindex' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='gindex' order by `Date` desc")));	

	$gindexXML = "<graph caption='Google Indexed Pages' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowgooglevalue/100)*100)."' yaxismaxvalue='".round(ceil($highgooglevalue/100)*10)."'  rotateNames='1'>";
	$gindexXML .= "<categories >";
	$googlehits = $wpdb->get_results($sql, ARRAY_A);
	myseostatus_sksort($googlehits,"Date",true);
	$datelist = array(); //List of dates we want to collect data from...
	if ($googlehits){
	    foreach ($googlehits as $hits) {
	    	$gindexXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    	//First time we go through the loop. Lets collect all the dates into an array so we can query the same dates for Bing.com and Yahoo.com
	    	$datelist[] = $hits['Date']; //Adds the dates to the array...
	    }

	}
	$gindexXML .= "</categories>";
	$gindexXML .= "<dataset seriesName='Google.com Indexed Pages' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";

//GOOGLE INDEXED PAGES.
	if ($googlehits){

	    foreach ($googlehits as $hits) {
			$gindexXML .= "	<set value='".$hits['value']."' />";
	    }

	}	
	
	$gindexXML .= "	</dataset>";			
	$gindexXML .= "</graph>";

		$url=$baseurl.'FCF_MSLine.swf';
	
	_e("<h4>Google.com Indexed Pages</h4>", 'myseostatus');	
	if ($googlehits){
	
		echo renderChart($url, "", $gindexXML, "googlechart", 600, 300);	
						}
	else {
		_e("<p>No data to display yet.</p>",'myseostatus');
	}

	
			
				?>

      
      <?php
// YAHOOOOO
//-----------


	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='yindex' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='yindex' order by `Date` desc")));	
	$highyahoovalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='yindex' order by `value` desc");
	$lowyahoovalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='yindex' order by `value` asc");
	$ysql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'yindex')) ";
	$yindexXML = "<graph caption='Yahoo.com Indexed Pages' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowyahoovalue/100)*100)."' yaxismaxvalue='".round(ceil($highyahoovalue/100)*10)."'  rotateNames='1'>";
	$yindexXML .= "<categories >";
	$yahoohits = $wpdb->get_results($ysql, ARRAY_A);
	myseostatus_sksort($yahoohits,"Date",true); //sort array data by key 'Date'
	if ($yahoohits){
	    foreach ($yahoohits as $hits) {
	    	$yindexXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$yindexXML .= "</categories>";
	$yindexXML .= "<dataset seriesName='Yahoo.com Indexed Pages' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($yahoohits){
	    foreach ($yahoohits as $hits) {
			$yindexXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$yindexXML .= "	</dataset>";			
	$yindexXML .= "</graph>";
_e("<h4>Yahoo.com Indexed Pages</h4>", 'myseostatus');	
	if ($yahoohits){	
	echo renderChart($url, "", $yindexXML, "yahoochart", 600, 300);
					}
	else {
		_e("<p>No data to display yet.</p>",'myseostatus');
	}
//-----------------
//YAHOOOOOO ENDS
   
   
//BING.COM
//-----------
	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='bindex' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='bindex' order by `Date` desc")));	
	
	$highbingvalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='bindex' order by `value` desc");
	$lowbingvalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='bindex' order by `value` asc");
	$ysql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'bindex')) ";
	$bindexXML = "<graph caption='Bing.com Indexed Pages' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowbingvalue/100)*100)."' yaxismaxvalue='".round(ceil($highbingvalue/100)*10)."'  rotateNames='1'>";
	$bindexXML .= "<categories >";
	$binghits = $wpdb->get_results($ysql, ARRAY_A);
	myseostatus_sksort($binghits,"Date",true); //sort array data by key 'Date'
	if ($binghits){
	    foreach ($binghits as $hits) {
	    	$bindexXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$bindexXML .= "</categories>";
	$bindexXML .= "<dataset seriesName='Bing.com Indexed Pages' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($binghits){
	    foreach ($binghits as $hits) {
			$bindexXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$bindexXML .= "	</dataset>";			
	$bindexXML .= "</graph>";
_e("<h4>Bing.com Indexed Pages</h4>", 'myseostatus');

	if ($binghits){	
		echo renderChart($url, "", $bindexXML, "bingchart", 600, 300);
				}
	else {
		_e("<p>No data to display yet.</p>",'myseostatus');
	}
//-----------------
//BING.COM ENDS      
      
      
      
  //ALTAVISTA.COM
//-----------
	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='aindex' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='aindex' order by `Date` desc")));	
	$highavalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='aindex' order by `value` desc");
	$lowavalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='aindex' order by `value` asc");
	$asql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'aindex')) ";
	$aindexXML = "<graph caption='Altavista.com Indexed Pages' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowavalue/100)*100)."' yaxismaxvalue='".round(ceil($highavalue/100)*10)."'  rotateNames='1'>";
	$aindexXML .= "<categories >";
	$ahits = $wpdb->get_results($asql, ARRAY_A);
	myseostatus_sksort($ahits,"Date",true); //sort array data by key 'Date'
	if ($ahits){
	    foreach ($ahits as $hits) {
	    	$aindexXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$aindexXML .= "</categories>";
	$aindexXML .= "<dataset seriesName='Altavista.com Indexed Pages' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($ahits){
	    foreach ($ahits as $hits) {
			$aindexXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$aindexXML .= "	</dataset>";			
	$aindexXML .= "</graph>";
_e("<h4>Altavista.com Indexed Pages</h4>", 'myseostatus');	
	
	
	if ($ahits){
		echo renderChart($url, "", $aindexXML, "achart", 600, 300);
			}
	else {
	
		_e("<p>No data to display yet.</p>",'myseostatus');
	
	}
//-----------------
//ALTAVISTA.COM ENDS          
      ?>
				<p><em>Charts rendered using <a href="http://www.fusioncharts.com" target="_blank">FusionCharts Free</a></em></p>
	
				</div>
			</div>
		</div>    



  		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('Backlinks Graphs', 'myseostatus'); ?></h3>
				<div class="inside">
<?php					


//YAHOO BACKLINKS
//-----------
	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='ylinks' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='ylinks' order by `Date` desc")));	
	$highyvalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='ylinks' order by `value` desc");
	$lowyyalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='ylinks' order by `value` asc");
	$gsql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'ylinks')) ";
	$yXML = "<graph caption='Yahoo.com Backlinks' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowyyalue/100)*100)."' yaxismaxvalue='".round(ceil($highyvalue/100)*10)."'  rotateNames='1'>";
	$yXML .= "<categories >";
	$yhits = $wpdb->get_results($gsql, ARRAY_A);
	myseostatus_sksort($yhits,"Date",true); //sort array data by key 'Date'
	if ($yhits){
	    foreach ($yhits as $hits) {
	    	$yXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$yXML .= "</categories>";
	$yXML .= "<dataset seriesName='Yahoo Backlinks' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($yhits){
	    foreach ($yhits as $hits) {
			$yXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$yXML .= "	</dataset>";			
	$yXML .= "</graph>";
_e("<h4>Yahoo.com Backlinks</h4>", 'myseostatus');	

	if ($yhits){
		echo renderChart($url, "", $yXML, "yahoobacklinkschart", 600, 300);
		}
	else {
	
		_e("<p>No data to display yet.</p>",'myseostatus');
	
	}
//-----------------
//YAHOO BACKLINKS ENDS   


//GOOGLE BACKLINKS
//-----------
	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='glinks' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='glinks' order by `Date` desc")));	
	$highgvalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='glinks' order by `value` desc");
	$lowgvalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='glinks' order by `value` asc");
	$gsql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'glinks')) ";
	$gXML = "<graph caption='Google.com Backlinks' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowgvalue/100)*100)."' yaxismaxvalue='".round(ceil($highgvalue/100)*10)."'  rotateNames='1'>";
	$gXML .= "<categories >";
	$ghits = $wpdb->get_results($gsql, ARRAY_A);
	myseostatus_sksort($ghits,"Date",true); //sort array data by key 'Date'
	if ($ghits){
	    foreach ($ghits as $hits) {
	    	$gXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$gXML .= "</categories>";
	$gXML .= "<dataset seriesName='Google Backlinks' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($ghits){
	    foreach ($ghits as $hits) {
			$gXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$gXML .= "	</dataset>";			
	$gXML .= "</graph>";
	_e("<h4>Google.com Backlinks</h4>", 'myseostatus');	
	if ($ghits){
			
		echo renderChart($url, "", $gXML, "googlebacklinkschart", 600, 300);
	}
	else {
	
		_e("<p>No data to display yet.</p>",'myseostatus');
	
	}


//-----------------
//GOOGLE BACKLINKS ENDS   



//ALTAVISTA BACKLINKS
//-----------
	$firstcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='alinks' order by `Date` asc")));
	$lastcheck =date_i18n(get_option('date_format') ,strtotime($wpdb->get_var("SELECT date  FROM `$table_name` where `datatype`='alinks' order by `Date` desc")));	
	$higavalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='alinks' order by `value` desc");
	$lowavalue=$wpdb->get_var("SELECT value  FROM `$table_name` where `datatype`='alinks' order by `value` asc");
	$asql="SELECT `id` , `Date` , `datatype` , `value` FROM `$table_name` WHERE ( (`Date` IN('".join("','", $datelist)."')) && (`datatype` = 'alinks')) ";
	$aXML = "<graph caption='Altavista.com Backlinks' subcaption='(from ".$firstcheck." to ".$lastcheck.")' hovercapbg='FFECAA' hovercapborder='F47E00' formatNumberScale='0' decimalPrecision='0' showvalues='0' numdivlines='3' numVdivlines='0' yaxisminvalue='".round(floor($lowavalue/100)*100)."' yaxismaxvalue='".round(ceil($higavalue/100)*10)."'  rotateNames='1'>";
	$aXML .= "<categories >";
	$ahits = $wpdb->get_results($asql, ARRAY_A);
	myseostatus_sksort($ahits,"Date",true); //sort array data by key 'Date'
	if ($ahits){
	    foreach ($ahits as $hits) {
	    	$aXML .= "<category name='".date_i18n(get_option('date_format') ,strtotime($hits['Date']))."' />";
	    }
	}
	$aXML .= "</categories>";
	$aXML .= "<dataset seriesName='Altavista Backlinks' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>";
	if ($ahits){
	    foreach ($ahits as $hits) {
			$aXML .= "	<set value='".$hits['value']."' />";
	    }
	}	
	$aXML .= "	</dataset>";			
	$aXML .= "</graph>";
_e("<h4>Altavista.com Backlinks</h4>", 'myseostatus');	
	if ($ahits){
		echo renderChart($url, "", $aXML, "altavistabacklinkschart", 600, 300);
	}
	else {
	
		_e("<p>No data to display yet.</p>",'myseostatus');
	
	}
	
//-----------------
//ALTAVISTA BACKLINKS ENDS   


?>

				<p><em>Charts rendered using <a href="http://www.fusioncharts.com" target="_blank">FusionCharts Free</a></em></p>
				</div>
			</div>
		</div>
      
   		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('Links for Manual Checking', 'myseostatus'); ?></h3>
				<div class="inside">
					<?php
					$blogurl=myseostatus_remove_http(get_bloginfo('url'));					
					$bing = "http://www.bing.com/search?q=site:".$blogurl."&go=&form=QBRE&filt=all&setmkt=en-US&setlang=en-US";
					$altavista = "http://www.altavista.com/web/results?itag=ody&q=site%3A".$blogurl."&kgs=0&kls=0";
					$google  = "http://www.google.com/search?q=site%3A".$blogurl."&start=0&ie=utf-8&oe=utf-8";
					$yahoo = "http://siteexplorer.search.yahoo.com/search?p=".urlencode($blogurl)."&bwm=p&bwms=p&fr=yfp-t-500&fr2=seo-rd-se";


					_e("<p>If you wish to check the data manually, you can use the direct links below:</p>"); 
					
					_e("<h4>Indexation</h4>");
					_e("<ul>");
						_e("<li><a href='$yahoo' target='_blank'>Yahoo</a>");
						_e("<li><a href='$google' target='_blank'>Google</a>");
						_e("<li><a href='$altavista' target='_blank'>Altavista</a>");
						_e("<li><a href='$bing' target='_blank'>Bing</a>");
					_e("</ul>");	
					
					$altavista = "http://www.altavista.com/web/results?itag=ody&q=link%3A".$blogurl."&kgs=0&kls=0";
					$google = "http://www.google.com/search?hl=en&lr=&q=link%3A".$blogurl."&btnG=Search";
					$yahoo = "http://siteexplorer.search.yahoo.com/search?p=".urlencode($blogurl)."&bwm=i&bwmo=d&bwmf=s";

					_e("<h4>Backlinks</h4>");
					_e("<ul>");
						_e("<li><a href='$yahoo' target='_blank'>Yahoo</a>");
						_e("<li><a href='$google' target='_blank'>Google</a>");
						_e("<li><a href='$altavista' target='_blank'>Altavista</a>");
					_e("</ul>");	
					
					_e("<p>Please note, the numbers you see might differ slightly from the numbers reported by mySEOStatus. The number mySEOStatus reports is at the time of the automatic check. The numbers change frequently on the search engines. mySEOStatus only checks once every day.</p><p>Please read the FAQ for more information.</p>");						
					
					?>
				</div>
			</div>
		</div>     
    

  		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('Export to .csv', 'myseostatus'); ?></h3>
				<div class="inside">
					
		
					<?php
					$exporturl=WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)). '/export.php';	
					
					$exporttext= "<a href='$exporturl' target='_blank'>Click here</a> to download the report.";
					?>
					<p><?php _e($exporttext); ?></p>
					
					<p><?php _e('<em>Please note: The data is formatted with semicolons (;) as seperator.</em>'); ?></p>
				</div>
			</div>
		</div>
		

  		<div id="poststuff" class="ui-sortable">
			<div class="postbox closed" >
				<h3><?php _e('Clear Database', 'myseostatus'); ?></h3>
				<div class="inside">
					<p><?php _e('Clicking on this button clears ALL indexation and backlinks data for this blog. <strong>Attention: </strong>You <strong>cannot</strong> undo clicking this button.', 'myseostatus'); ?></p>
					
					<p><?php _e('<em>Only click this if you are absolutely certain!</em>'); ?></p>
					<form name="form2" method="post" action="<?php echo $location; ?>">
					
				
						<p class="submit">
						
							<input type="hidden" name="_myseostatusnonce" value="<?php echo wp_create_nonce('_myseostatusnonce'); ?>" />
							<input type="hidden" name="action" value="clear" />
							<input class="button" type="submit" name="myseostatus_clear" value="<?php _e('Empty Database', 'myseostatus'); ?>" />
						</p>
					</form>
				</div>
			</div>
		</div>
		
		<div id="poststuff" class="ui-sortable">
			<div class="postbox open" >
				<h3><?php _e('my SEO Status Credits', 'myseostatus') ?></h3>
				<div class="inside">
				<?php
					$baseurl=WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)). '/mywordpresssm.jpg';	
					?>
					<p><?php _e('This Plugin was created by', 'myseostatus'); ?></p>
					<p><?php _e("<a href='http://mywordpress.com' target='_blank'><img src='$baseurl' border=0></a>", 'myseostatus'); ?></p>
				</div>
			</div>
		</div>

   		<script type="text/javascript">
		<!--
		<?php if ( version_compare( $wp_version, '2.6.999', '<' ) ) { ?>
		jQuery('.postbox h3').prepend('<a class="togbox">+</a> ');
		<?php } ?>
		jQuery('.postbox h3').click( function() { jQuery(jQuery(this).parent().get(0)).toggleClass('closed'); } );
		jQuery('.postbox.close-me').each(function(){
			jQuery(this).addClass("closed");
		});
		//-->
		</script>
</div> 

<?php
 
}


// ### Adding the admin menu to the WP-Admin interface
function myseostatus_admin_menu() {
  if (function_exists('add_submenu_page')) {
    add_options_page('my SEO Status', 'my SEO Status', 8, basename(__FILE__), 'myseostatus_admin_options');


  }
}


// ### mySEOStatus CRON JOB... (pseudo-cron)...
function myseostatus_cron(){ 
	$myseostatuscrondelay=get_option('myseostatus_cron_delay');
	if (!$myseostatuscrondelay<>'') {update_option( 'myseostatus_cron_delay', 24*60 );} 	
	$last = get_option(PLUGIN_MYSEOSTATUS_LAST_CRON, false);
	$now= time();
	$target= ($last + ($myseostatuscrondelay * 60));
	$temp=$target-$now;
	$last=true;
	if ($now > $target) {
		update_option(PLUGIN_MYSEOSTATUS_LAST_CRON, time());
		global $wpdb;
		$table_name = $wpdb->prefix . "myseostatus";	
		$blogurl=myseostatus_remove_http(get_bloginfo('url'));
		$timestamp = date ("Y-m-d H:i:s", time());


//Checking and updating Bing Indexation
		$bingcount=myseostatus_checkbingindex($blogurl);
		if ($bingcount<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'bindex', '".mysql_real_escape_string($bingcount)."');";
			$success = mysql_query($sql);
		}


//Checking and updating Yahoo Backlinks
		$yahoolinks= myseostatus_checkyahoolinks($blogurl);
		if ($yahoolinks<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'ylinks', '".mysql_real_escape_string($yahoolinks)."');";
			$success = mysql_query($sql);
		}
		

//Checking and updating Yahoo Indexation
		$yahoocount=myseostatus_checkyahooindex($blogurl);	
		if ($yahoocount<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'yindex', '".mysql_real_escape_string($yahoocount)."');";
			$success = mysql_query($sql);
		}

//Checking and updating Google Indexation
		$googlecount=myseostatus_checkgoogleindex($blogurl);
		if ($googlecount<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'gindex', '".mysql_real_escape_string($googlecount)."');";
			$success = mysql_query($sql);
		}

//Checking and updating Google Backlinks
		$googlelinks= myseostatus_checkgooglelinks($blogurl);	
		if ($googlelinks<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'glinks', '".mysql_real_escape_string($googlelinks)."');";
			$success = mysql_query($sql);
		}		
		
				
//Checking and updating AltaVista Indexation
		$altavistaindex= myseostatus_checkaltavistaindex($blogurl);	
		if ($altavistaindex<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'aindex', '".mysql_real_escape_string($altavistaindex)."');";
			$success = mysql_query($sql);
		}		
				

//Checking and updating AltaVista Backlinks
		$altavistalinks= myseostatus_checkaltavistalinks($blogurl);
		if ($altavistalinks<>'') {
			$sql="INSERT INTO `$table_name` ( `date`, `datatype`, `value`) VALUES ('".mysql_real_escape_string($timestamp)."', 'alinks', '".mysql_real_escape_string($altavistalinks)."');";
			$success = mysql_query($sql);
		}				
	}
}



// Add settings link on plugin page
function myseostatus_settings_link($links) {
  $settings_link = '<a href="options-general.php?page=myseostatus.php">Settings</a>';
  array_unshift($links, $settings_link);
  return $links;
}


$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'myseostatus_settings_link' );


add_action('init', 'myseostatus_cron', 0); // 0 Priority filter
add_action('admin_menu', 'myseostatus_admin_menu');
add_action('wp_dashboard_setup', 'myseostatus_add_dashboard_widgets' );
register_activation_hook(__FILE__,'myseostatus_install');


?>
